
import ModelIO
import MetalKit
import simd

//#########################################################################

extension MDLVertexDescriptor {
    var vertexAttributes: [MDLVertexAttribute] {
        return attributes as! [MDLVertexAttribute]
    }
    var bufferLayouts: [MDLVertexBufferLayout] {
        return layouts as! [MDLVertexBufferLayout]
    }
}

//#########################################################################

class Node {
    var mesh: MTKMesh?
    var transform: simd_float4x4 = matrix_identity_float4x4
    var color: Int = 7
    init(mesh: MTKMesh) { self.mesh = mesh }
}

//#########################################################################

enum LightType : UInt32 {
    case ambient
    case directional
}

class Light {
    var type = LightType.directional
    var color = SIMD3<Float>(1, 1, 1)
    var intensity: Float = 1.0
    var direction = SIMD3<Float>(1, 0, 0)
}

//#########################################################################
